<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'ProofPoints',
  props: {
    icon: {
      type: String,
      required: false,
      default: null,
    },
    upperText: {
      type: String,
      required: false,
      default: null,
    },
    text: {
      type: String,
      required: true,
    },
    name: {
      type: String,
      required: false,
      default: null,
    },
    image: {
      type: String,
      required: false,
      default: null,
    },
    link: {
      type: String,
      required: false,
      default: null,
    },
    quote: {
      type: Boolean,
      required: true,
    },
    dataGaName: {
      type: String,
      required: false,
      default: null,
    },
  },
});
</script>

<template>
  <SlpRow class="slp-mt-32 slp-mb-64">
    <SlpColumn :cols="1" />
    <SlpColumn :cols="3" class="logo_wrapper" style="align-self: flex-end">
      <div v-if="!image">
        <SlpTypography class="text"
          >2023 Global <br />DevSecOps Report</SlpTypography
        >
      </div>
      <div v-else>
        <img class="image_logo" :src="image" />
      </div>
    </SlpColumn>
    <SlpColumn :cols="8" class="slp-p-32 quote">
      <SlpTypography v-if="upperText" class="slp-mb-24" tag="p">
        {{ upperText }}</SlpTypography
      >
      <div v-if="!icon">
        <nuxt-img
          style="color: #210c17"
          alt=""
          class="slp-pb-16"
          src="/nuxt-images/why-gitlab/quote.svg"
          format="webp"
          quality="99"
        />
      </div>
      <div v-else class="icon">
        <SlpIcon
          :name="icon"
          variant="marketing"
          size="md"
          hex-color="#A989F5"
        />
      </div>
      <SlpTypography tag="p" :class="{ 'quote-text': quote }">
        {{ text }}
      </SlpTypography>
      <SlpTypography v-if="name" tag="p" variant="body2" class="slp-pt-16">
        {{ name }}
      </SlpTypography>
      <SlpButton
        v-if="link"
        class="slp-mt-32"
        variant="tertiary"
        :href="link"
        style="color: #fff"
        :data-ga-name="dataGaName"
        data-ga-location="body"
        >Read more
        <SlpIcon
          class="learn-more-icon"
          name="chevron-lg-right"
          variant="product"
      /></SlpButton>
    </SlpColumn>
  </SlpRow>
</template>

<style scoped>
.quote {
  border: 1px solid #45424d;
  border-radius: 4px;
  position: relative;
  box-sizing: border-box;

  &::before,
  &::after {
    content: '';
    position: absolute;
    display: block;
    left: -13px;
    width: 0;
    height: 0;
  }

  &::before {
    /* This is the border triangle */
    border-top: 13px solid transparent;
    border-bottom: 13px solid transparent;
    border-right: 13px solid #45424d;
    bottom: 20px;
  }

  &::after {
    /* This is the background triangle */
    border-top: 11px solid transparent;
    border-bottom: 11px solid transparent;
    border-right: 11px solid #171321;
    bottom: 22px;
    transform: translateX(2px);
  }
}

@media screen and (max-width: 768px) {
  .quote::before,
  .quote::after {
    left: auto;
    bottom: auto;
    top: 100%;
    border-left: 13px solid transparent;
    border-right: 13px solid transparent;
    border-top-width: 0;
    border-bottom-width: 0;
  }

  .quote::before {
    border-top: 13px solid #45424d;
  }

  .quote::after {
    border-top: 12px solid #171321;
    left: 30px;
    transform: translateX(2px) translateY(-1px);
  }
}

.logo_wrapper {
  @media screen and (max-width: 768px) {
    order: 2;
  }
}

.icon {
  padding-bottom: 16px;
  color: #a989f5;
}

.text {
  font-weight: 600;
  float: right;
  padding: 0 24px 16px 0;

  @media screen and (max-width: 768px) {
    padding: 24px 24px 16px 0;
  }
}

.quote-text {
  font-style: italic;
  font-size: 20px;
  line-height: 32px;
}

.image_logo {
  max-width: 200px;
  float: right;
  padding: 0 24px 16px 0;

  @media screen and (max-width: 1024px) {
    padding: 24px 24px 16px 0;
  }
}
</style>
